#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

int n;
int p[1 << 20];
vector< pair<int,int> > a[1 << 20];
int path[1 << 20], lvl[1 << 20];

void read() {
    scanf("%d", &n);
    for (int i = 2; i <= n; i++) {
        int c;
        
        scanf("%d%d", &p[i], &c);
        a[p[i]].push_back(make_pair(i, c));
    }
}

void dfs(int x, int y) {
    path[x] = y;
    
    for (int i = 0; i < (int)a[x].size(); i++) {
        lvl[ a[x][i].first ] = lvl[x] + 1;
        dfs(a[x][i].first, y + a[x][i].second);
    }
}

void solve() {
    lvl[1] = 0;
    dfs(1, 0);
    int q;
    
    scanf("%d", &q);
    while (q --) {
        int w, e, t;
        int c1, c2, c3;
        
        scanf("%d%d%d", &w, &e, &t);
        c1 = path[w];
        c2 = path[e];
        
        while (lvl[w] > lvl[e]) w = p[w];
        while (lvl[e] > lvl[w]) e = p[e];
        while (w != e) {
            w = p[w];
            e = p[e];
        }
        
        c3 = path[w];
        
        c1 -= c3;
        c2 -= c3;
        
        int ans = c3 + c1 + c1 + c2;
        ans = min(ans, c1 + c3 + t);
        ans = min(ans, c3 + 2 * t + c2);
        ans = min(ans, t + c1 + c2);
        
        printf ("%d\n", ans);
    }
}

int main() {
    read();
    solve();
    
    return 0;
}
